/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: APURA_LISTA                                                          */
/*                                                                            */
/* Descrio:                                                                 */
/* APURA AS MELHORES COTACOES PARA A LISTA DE PRECOS                          */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 03/04/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes:                                                               */
/* 08/05/2000 -  Adriano de Arajo                                            */
/*    Foi acrescentada verficaco para o tipo de fornecedor                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/******************************************************************************/


IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'APURA_LISTA'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)

   DROP PROCEDURE APURA_LISTA;
GO

CREATE PROCEDURE APURA_LISTA @P_CDFILIAL     VARCHAR(4),
                             @P_NRSEQPRELIST VARCHAR(10)

AS

DECLARE @V_CDPRODESTO   VARCHAR(10);
DECLARE @V_CDPRODESTAUX VARCHAR(10);
DECLARE @V_NRCOTESCAUTO NUMERIC(10);
DECLARE @V_VRPRECO      NUMERIC(15,5);
DECLARE @V_CDPRODUTO    VARCHAR(10);
DECLARE @V_CDMARCA      VARCHAR(5);
DECLARE @V_CDFORNECED   VARCHAR(21);
DECLARE @V_CDREGIAO     VARCHAR(3);
DECLARE @V_CDREGIAOAUX  VARCHAR(3);
DECLARE @V_NRCOLEPRECO  VARCHAR(10);

DECLARE @V_NRCONTA INT;

BEGIN

  UPDATE ITMPREVLIST
   SET IDITMSELLIS  = 'N'
  WHERE
   ITMPREVLIST.CDFILIAL     = @P_CDFILIAL      AND
   ITMPREVLIST.NRSEQPRELIST = @P_NRSEQPRELIST;

  SELECT @V_NRCOTESCAUTO = NRCOTESCAUTO
  FROM PARASUPRI
  WHERE
   CDFILIAL = @P_CDFILIAL;

  IF @V_NRCOTESCAUTO IS NULL
  BEGIN
    SET @V_NRCOTESCAUTO = 0;
  END;

  DECLARE C_COTACAO CURSOR FOR
  SELECT
     ITEMCOLE.CDPRODUTO,--PRODUTO.CDPRODESTO

     CASE PARASUPRI.IDTIPOAPUR
         WHEN NULL THEN (ITEMCOLE.VRPRECUNIITM / PRODUTO.VRFATOCONV)
         WHEN '1'  THEN ITEMCOLE.VRPRECECOITM
         ELSE ITEMCOLE.VRPRECOITMPI
     END,

     ITEMCOLE.NRCOLEPRECO,
     ITEMCOLE.CDPRODUTO,
     ITEMCOLE.CDMARCA,
     ITEMCOLE.CDFORNECED,
     ITEMCOLE.CDREGIAO
  FROM
     PARASUPRI,
     ITMPREVLIST,
     PRODUTO,
     FORNECEDOR,
     ITEMCOLE
  WHERE
     PARASUPRI.CDFILIAL       = @P_CDFILIAL            AND
     ITMPREVLIST.CDFILIAL     = @P_CDFILIAL            AND
     ITMPREVLIST.NRSEQPRELIST = @P_NRSEQPRELIST        AND
     ITMPREVLIST.CDPRODUTO    = PRODUTO.CDPRODUTO      AND
     ITMPREVLIST.CDFORNECED   = FORNECEDOR.CDFORNECED  AND
     ITMPREVLIST.CDFILIAL     = ITEMCOLE.CDFILIAL      AND
     ITMPREVLIST.NRCOLEPRECO  = ITEMCOLE.NRCOLEPRECO   AND
     ITMPREVLIST.CDFORNECED   = ITEMCOLE.CDFORNECED    AND
     ITMPREVLIST.CDREGIAO     = ITEMCOLE.CDREGIAO      AND
     ITMPREVLIST.CDPRODUTO    = ITEMCOLE.CDPRODUTO     AND
     ITMPREVLIST.CDMARCA      = ITEMCOLE.CDMARCA       AND
     FORNECEDOR.IDTIPOFORN    = 'N'                    AND
     FORNECEDOR.IDSITUCADA    = 'A'                    AND
     NOT EXISTS
       (SELECT  /* Retirando os fornecedores no-qualificados */
         QUALIFICACAO.CDQUALIF
        FROM
          QUALIFICACAO
        WHERE
          FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF AND
         (FORNECEDOR.IDFORNAUTO = 'N') AND
         ((QUALIFICACAO.IDPERCOTCMP = '2') OR
          ( (PARASUPRI.IDULTIDTVALQ = 'D' AND
            CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > FORNECEDOR.DTVALQUALIF) OR
           (PARASUPRI.IDULTIDTVALQ = 'M' AND
            CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF) - DAY(FORNECEDOR.DTVALQUALIF)) ) ) ) AND
      NOT EXISTS
      (SELECT
          QFOMARPROD.CDMARCA
       FROM
          QFOMARPROD
       WHERE
         (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
         (QFOMARPROD.CDMARCA   = ITMPREVLIST.CDMARCA) AND
         ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
          ((QFOMARPROD.IDAPRMARPRO = 'S') AND
             ((PARASUPRI.IDULTIDTVALQ = 'M' AND
               CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA) - DAY(DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA)) ) OR
              (PARASUPRI.IDULTIDTVALQ = 'D' AND
               CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > QFOMARPROD.DTVALAPROVA)) ) )) AND
      (EXISTS
        (SELECT
           QFOMARPROD.CDMARCA
         FROM
           QFOMARPROD
         WHERE
           QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
           QFOMARPROD.CDMARCA   = ITMPREVLIST.CDMARCA) OR

         EXISTS
         (SELECT
           PARASUPRI.CDMARCA
         FROM
           PARASUPRI
         WHERE
           PARASUPRI.CDFILIAL    = @P_CDFILIAL AND
           (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) )AND

      NOT EXISTS
        (SELECT
            QFOPRODFORN.CDPRODUTO
         FROM
            QFOPRODFORN,
            PARASUPRI
         WHERE
           PARASUPRI.CDFILIAL = @P_CDFILIAL  AND
           (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
           (QFOPRODFORN.CDFORNECED= FORNECEDOR.CDFORNECED) AND
           ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
            ((QFOPRODFORN.IDFORNAPROV = 'S') AND
               ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                 CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > DATEADD(MM, 1, QFOPRODFORN.DTVALPRFORN) - DAY(QFOPRODFORN.DTVALPRFORN)) OR
                (PARASUPRI.IDULTIDTVALQ = 'D' AND
                 CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > QFOPRODFORN.DTVALPRFORN)) ) ))
  ORDER BY
     ITEMCOLE.CDPRODUTO,----PRODUTO.CDPRODESTO
     ITEMCOLE.CDREGIAO,
     CASE PARASUPRI.IDTIPOAPUR
         WHEN NULL THEN (ITEMCOLE.VRPRECUNIITM / PRODUTO.VRFATOCONV)
         WHEN '1'  THEN ITEMCOLE.VRPRECECOITM
         ELSE ITEMCOLE.VRPRECOITMPI
     END;

  OPEN C_COTACAO;
  FETCH NEXT FROM C_COTACAO INTO @V_CDPRODESTO,
                                 @V_VRPRECO,
                                 @V_NRCOLEPRECO,
                                 @V_CDPRODUTO,
                                 @V_CDMARCA,
                                 @V_CDFORNECED,
                                 @V_CDREGIAO
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
    SET @V_NRCONTA = 1;
    SET @V_CDPRODESTAUX = @V_CDPRODESTO;
    SET @V_CDREGIAOAUX  = @V_CDREGIAO;

    WHILE (@@FETCH_STATUS = 0) AND
          (@V_CDPRODESTAUX = @V_CDPRODESTO) AND
          (@V_CDREGIAOAUX  = @V_CDREGIAO)
    BEGIN
      IF (@V_NRCONTA <= @V_NRCOTESCAUTO) OR (@V_NRCOTESCAUTO = 0)
      BEGIN
         UPDATE ITMPREVLIST
         SET IDITMSELLIS  = 'S'
         WHERE
          ITMPREVLIST.CDFILIAL     = @P_CDFILIAL      AND
          ITMPREVLIST.NRCOLEPRECO  = @V_NRCOLEPRECO  AND
          ITMPREVLIST.NRSEQPRELIST = @P_NRSEQPRELIST  AND
          ITMPREVLIST.CDFORNECED   = @V_CDFORNECED    AND
          ITMPREVLIST.CDREGIAO     = @V_CDREGIAO      AND
          ITMPREVLIST.CDPRODUTO    = @V_CDPRODUTO     AND
          ITMPREVLIST.CDMARCA      = @V_CDMARCA;
      END;
      FETCH NEXT FROM C_COTACAO INTO @V_CDPRODESTO,
                                     @V_VRPRECO,
                                     @V_NRCOLEPRECO,
                                     @V_CDPRODUTO,
                                     @V_CDMARCA,
                                     @V_CDFORNECED,
                                     @V_CDREGIAO
      SET @V_NRCONTA = @V_NRCONTA + 1;
    END;
  END;
  CLOSE C_COTACAO;
  DEALLOCATE C_COTACAO;
END;
GO
